about summary refs log tree commit diff
path: root/tests/optimise-store.sh
diff options
context:
space:
mode:
authorEelco Dolstra <eelco.dolstra@logicblox.com>2012-07-23T21·40-0400
committerEelco Dolstra <eelco.dolstra@logicblox.com>2012-07-23T21·40-0400
commit0f65793f94bd89c973482ac949be1e96e876762b (patch)
tree5038f984996e3c630fd64745a511aa96a021815f /tests/optimise-store.sh
parent680ab6f83def2b636200204542ca352631a46f85 (diff)
Add a test for Nix store optimisation
Diffstat (limited to 'tests/optimise-store.sh')
-rw-r--r--tests/optimise-store.sh26
1 files changed, 26 insertions, 0 deletions
diff --git a/tests/optimise-store.sh b/tests/optimise-store.sh
new file mode 100644
index 0000000000..4d8077997d
--- /dev/null
+++ b/tests/optimise-store.sh
@@ -0,0 +1,26 @@
+source common.sh
+
+clearStore
+
+outPath1=$(echo 'with import ./config.nix; mkDerivation { name = "foo1"; builder = builtins.toFile "builder" "mkdir $out; echo hello > $out/foo"; }' | nix-build - --no-out-link)
+outPath2=$(echo 'with import ./config.nix; mkDerivation { name = "foo2"; builder = builtins.toFile "builder" "mkdir $out; echo hello > $out/foo"; }' | nix-build - --no-out-link)
+
+inode1="$(perl -e "print ((lstat('$outPath1/foo'))[1])")"
+inode2="$(perl -e "print ((lstat('$outPath2/foo'))[1])")"
+if [ "$inode1" != "$inode2" ]; then
+    echo "inodes do not match"
+    exit 1
+fi
+
+nlink="$(perl -e "print ((lstat('$outPath1/foo'))[3])")"
+if [ "$nlink" != 3 ]; then
+    echo "link count incorrect"
+    exit 1
+fi
+
+nix-store --gc
+
+if [ -n "$(ls $NIX_STORE_DIR/.links)" ]; then
+    echo ".links directory not empty after GC"
+    exit 1
+fi